#include <stdint.h>

#ifdef DEBUG
#include "malloc.h"
#include "itox.h"
#include "strlen.h"
#include "null.h"
#endif
#define DEBUG_ADD
static unsigned long long instructioncounter= 0LL;

#ifdef DEBUG
	#define print_str_debug callbacks_print_str
	#define print_int_debug callbacks_print_int
	#define print_unsigned_long_long_debug callbacks_print_unsigned_long_long
#else
	#define print_str_debug(a) 
	#define print_int_debug(a) 
	#define assert(a)
#endif


#ifdef DEBUG
#define write_fd 2
void callbacks_print_unsigned_long_long(unsigned long long x)
{
	char buf[100];
	itox(x,buf);
	write(write_fd,buf,strlen(buf));
}
void callbacks_print_str(char *s)
{
	write(write_fd,s,strlen(s));
}
#endif

void count_instruction()
{
	instructioncounter++;
	print_str_debug("instructioncounter:");
	print_unsigned_long_long_debug(instructioncounter);
	print_str_debug("\n");
}
